NNG_HTTP_CONN_WRITE(3http)

NAME
nng_http_conn_write - write to HTTP connection

SYNOPSIS

    #include <nng/nng.h>
    #include <nng/supplemental/http/http.h>
    void nng_http_conn_write(nng_http_conn *conn, nng_aio *aio);

DESCRIPTION

The nng_http_conn_write() function starts an asynchronous write to the HTTP connection conn from the scatter/gather vector located in the asynchronous I/O structure aio.

    Note

    The nng_aio_set_iov() function must have been called first, to set the scatter/gather vector for aio.

This function returns immediately, with no return value. Completion of the operation is signaled via the aio, and the final result may be obtained via nng_aio_result(). That result will either be zero or an error code.

The I/O operation completes as soon as at least one byte has been written, or an error has occurred. Therefore, the number of bytes written may be less than requested. The actual number of bytes written can be determined with nng_aio_count().

    Tip

    This function is intended to facilitate uses cases that involve changing the protocol from HTTP, such as WebSocket. Most applications will never need to use this function.

RETURN VALUES

None.

ERRORS

NNG_ECANCELED
    The operation was canceled.

NNG_ECLOSED
    The connection was closed.

NNG_ECONNRESET
    The peer closed the connection.

NNG_EINVAL
    The aio does not contain a valid scatter/gather vector.

NNG_ENOMEM
    Insufficient free memory to perform the operation.

NNG_ENOTSUP
    HTTP operations are not supported.

NNG_ETIMEDOUT
    Timeout waiting for data from the connection.

SEE ALSO

nng_aio_alloc(3), nng_aio_count(3), nng_aio_result(3), nng_aio_set_iov(3), nng_http_client_connect(3http), nng_http_conn_write_all(3http), nng_http_handler_alloc(3http), nng_strerror(3), nng(7)